import * as i0 from '@angular/core';
import { Component, ViewEncapsulation, Injectable, Input, Directive, HostListener, NgModule } from '@angular/core';
import * as i2 from '@angular/common';
import { CommonModule } from '@angular/common';

class DefaultSpinnerComponent {
}
DefaultSpinnerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: DefaultSpinnerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
DefaultSpinnerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.8", type: DefaultSpinnerComponent, selector: "ng-component", ngImport: i0, template: '<div class="lds-dual-ring"></div>', isInline: true, styles: [".lds-dual-ring{display:inline-block;width:80px;height:80px}.lds-dual-ring:after{content:\" \";display:block;width:45px;height:45px;margin:8px;border-radius:50%;border:6px solid #2959a1;border-color:#2959a1 transparent #2959a1 transparent;animation:lds-dual-ring 1.2s linear infinite}@keyframes lds-dual-ring{0%{transform:rotate(0)}to{transform:rotate(360deg)}}\n"], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: DefaultSpinnerComponent, decorators: [{
            type: Component,
            args: [{ template: '<div class="lds-dual-ring"></div>', encapsulation: ViewEncapsulation.None, styles: [".lds-dual-ring{display:inline-block;width:80px;height:80px}.lds-dual-ring:after{content:\" \";display:block;width:45px;height:45px;margin:8px;border-radius:50%;border:6px solid #2959a1;border-color:#2959a1 transparent #2959a1 transparent;animation:lds-dual-ring 1.2s linear infinite}@keyframes lds-dual-ring{0%{transform:rotate(0)}to{transform:rotate(360deg)}}\n"] }]
        }] });

class LoadingSpinnerConfig {
    constructor() {
        this.component = DefaultSpinnerComponent;
    }
}
LoadingSpinnerConfig.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerConfig, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
LoadingSpinnerConfig.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerConfig, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerConfig, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class LoadingSpinnerComponent {
    constructor(_spinnerConfig, injector) {
        this._spinnerConfig = _spinnerConfig;
        this.injector = injector;
    }
    get component() {
        return this._spinnerConfig.component;
    }
}
LoadingSpinnerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerComponent, deps: [{ token: LoadingSpinnerConfig }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Component });
LoadingSpinnerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.2.8", type: LoadingSpinnerComponent, selector: "dp-loading-spinner", inputs: { message: "message" }, ngImport: i0, template: "<div class=\"dp-spinner-container\">\r\n    <div *ngComponentOutlet=\"component; injector: injector\"></div>\r\n    <!-- <div class=\"lds-dual-ring\"></div> -->\r\n    <p *ngIf=\"message\">{{message}}</p>\r\n</div>", styles: [".dp-spinner-container{display:flex;flex-direction:column;justify-content:center;align-items:center;position:fixed;z-index:500;background-color:#fff;inset:0}.dp-spinner-container p{font-size:18px;margin-top:10px}.dp-spinner-parent,[dp-spinner-parent]{position:relative;min-height:100px}.dp-spinner-parent .dp-spinner-container,[dp-spinner-parent] .dp-spinner-container{position:absolute}\n"], dependencies: [{ kind: "directive", type: i2.NgComponentOutlet, selector: "[ngComponentOutlet]", inputs: ["ngComponentOutlet", "ngComponentOutletInjector", "ngComponentOutletContent", "ngComponentOutletNgModule", "ngComponentOutletNgModuleFactory"] }, { kind: "directive", type: i2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'dp-loading-spinner', encapsulation: ViewEncapsulation.None, template: "<div class=\"dp-spinner-container\">\r\n    <div *ngComponentOutlet=\"component; injector: injector\"></div>\r\n    <!-- <div class=\"lds-dual-ring\"></div> -->\r\n    <p *ngIf=\"message\">{{message}}</p>\r\n</div>", styles: [".dp-spinner-container{display:flex;flex-direction:column;justify-content:center;align-items:center;position:fixed;z-index:500;background-color:#fff;inset:0}.dp-spinner-container p{font-size:18px;margin-top:10px}.dp-spinner-parent,[dp-spinner-parent]{position:relative;min-height:100px}.dp-spinner-parent .dp-spinner-container,[dp-spinner-parent] .dp-spinner-container{position:absolute}\n"] }]
        }], ctorParameters: function () { return [{ type: LoadingSpinnerConfig }, { type: i0.Injector }]; }, propDecorators: { message: [{
                type: Input
            }] } });

class SpinnerParentDirective {
    constructor(_element) {
        this._element = _element;
    }
    adjustSpinnerLocations() {
        if (this._spinners) {
            this._spinners.forEach(spinner => {
                spinner.style.top = this._element.nativeElement.scrollTop + 'px';
                if (this._element.nativeElement.scrollTop > 0) {
                    spinner.style.bottom = (-this._element.nativeElement.scrollTop) + 'px';
                }
                else {
                    spinner.style.bottom = '0';
                }
            });
        }
    }
    ngAfterViewInit() {
        this._spinners = this._element.nativeElement.querySelectorAll('.dp-spinner-container');
        this.adjustSpinnerLocations();
    }
    onScroll() {
        this.adjustSpinnerLocations();
    }
}
SpinnerParentDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: SpinnerParentDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
SpinnerParentDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "14.0.0", version: "14.2.8", type: SpinnerParentDirective, selector: "[dp-spinner-parent],.dp-spinner-parent", host: { listeners: { "scroll": "onScroll()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: SpinnerParentDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[dp-spinner-parent],.dp-spinner-parent'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { onScroll: [{
                type: HostListener,
                args: ['scroll']
            }] } });

class LoadingSpinnerModule {
}
LoadingSpinnerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
LoadingSpinnerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerModule, declarations: [LoadingSpinnerComponent,
        DefaultSpinnerComponent,
        SpinnerParentDirective], imports: [CommonModule], exports: [LoadingSpinnerComponent,
        DefaultSpinnerComponent,
        SpinnerParentDirective] });
LoadingSpinnerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.2.8", ngImport: i0, type: LoadingSpinnerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        LoadingSpinnerComponent,
                        DefaultSpinnerComponent,
                        SpinnerParentDirective
                    ],
                    imports: [
                        CommonModule,
                    ],
                    exports: [
                        LoadingSpinnerComponent,
                        DefaultSpinnerComponent,
                        SpinnerParentDirective
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-loading-spinner
 */

/**
 * Generated bundle index. Do not edit.
 */

export { DefaultSpinnerComponent, LoadingSpinnerComponent, LoadingSpinnerConfig, LoadingSpinnerModule, SpinnerParentDirective };
//# sourceMappingURL=developer-partners-ngx-loading-spinner.mjs.map
